package com.nokia.dingtalk_auto.controller;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.nokia.common.http.R;
import com.nokia.dingtalk_auto.service.TslTaskService;

/**
 * 投诉清单各地市投诉率
 */
@RequestMapping("/dingtalk-auto/task/tsl")
@RestController
public class TslTaskController {

    @Autowired
    private TslTaskService tslTaskService;

    /**
     * 撤回消息
     * 
     * @param messageIds
     * @return
     */
    @PostMapping("/recall")
    public R recallMessage(@RequestBody String messageIds) {
        try {
            String[] split = messageIds.split(",");
            List<String> messageIdList = new ArrayList<>();
            for (String messageId : split) {
                messageIdList.add(messageId.trim());
            }
            tslTaskService.recallMessage(messageIdList);
            return R.ok().message("撤回成功");
        } catch (Exception e) {
            e.printStackTrace();
            return R.error().message(e.getMessage());
        }
    }

    /**
     * 手动发送消息
     * 
     * @param day
     * @return
     */
    @PostMapping("/send")
    public R sendManually(@RequestBody String day) {
        try {
            tslTaskService.runTaskManually(day);
            return R.ok().message("发送成功");
        } catch (Exception e) {
            e.printStackTrace();
            return R.error().message(e.getMessage());
        }
    }
}
